; PureBasic Visual Designer v3.95 build 1485 (PB4Code)


;- Window Constants
;
Enumeration
  #Window_0
EndEnumeration

;- Gadget Constants
;
Enumeration
  #Combo_PortName
  #Combo_PortBaud
  #Text_PortState
  #String_Byte_1
  #String_Byte_2
EndEnumeration

Procedure NewCom(Port.s, Baud) ;     

If IsSerialPort(1)  ;    
 CloseSerialPort(1) ;  
 Delay(100)
EndIf
                    ;  
If OpenSerialPort(1, Port, Baud, #PB_SerialPort_NoParity, 8, 1, #PB_SerialPort_NoHandshake, 256, 256)>0
  SetGadgetText(#Text_PortState, "  ")
  SetGadgetColor(#Text_PortState, #PB_Gadget_FrontColor, RGB(31, 94, 84) )
Else
  SetGadgetText(#Text_PortState, "   ")
  SetGadgetColor(#Text_PortState, #PB_Gadget_FrontColor, RGB(255, 0, 0) )
EndIf

EndProcedure

Procedure InCOM_Thread(*v) ;         100   
Static ByteNumber.c
Protected Byte.c

 Repeat
   If IsSerialPort(1)               ;  
     If AvailableSerialPortInput(1) ;   
        ReadSerialPortData(1, @Byte, 1) ;  
        If ByteNumber=0             ;   
          ByteNumber=1
          SetGadgetText(#String_Byte_1, Str(Byte))
        Else                        ;   
          ByteNumber=0
          SetGadgetText(#String_Byte_2, Str(Byte))
        EndIf
     EndIf
   EndIf
   Delay(100)
 ForEver
 
EndProcedure

                                      ;     
Procedure Open_Window_0()
  If OpenWindow(#Window_0, 0, 0, 300, 130, "ComTermo",  #PB_Window_MinimizeGadget | #PB_Window_Invisible | #PB_Window_ScreenCentered )
      TextGadget(#PB_Any, 10, 20, 35, 15, "")
      ComboBoxGadget(#Combo_PortName, 45, 15, 75, 20)
        For i=1 To 10
          AddGadgetItem(#Combo_PortName,-1,"COM"+Str(i))
        Next i
        SetGadgetState(#Combo_PortName,0)
      TextGadget(#PB_Any, 140, 20, 55, 15, "")
      ComboBoxGadget(#Combo_PortBaud, 200, 15, 80, 20)
         AddGadgetItem(#Combo_PortBaud,-1,"75")
         AddGadgetItem(#Combo_PortBaud,-1,"110")
         AddGadgetItem(#Combo_PortBaud,-1,"134")
         AddGadgetItem(#Combo_PortBaud,-1,"150")
         AddGadgetItem(#Combo_PortBaud,-1,"300")
         AddGadgetItem(#Combo_PortBaud,-1,"600")
         AddGadgetItem(#Combo_PortBaud,-1,"1200")
         AddGadgetItem(#Combo_PortBaud,-1,"1800")
         AddGadgetItem(#Combo_PortBaud,-1,"2400")
         AddGadgetItem(#Combo_PortBaud,-1,"4800")
         AddGadgetItem(#Combo_PortBaud,-1,"7200")  
         AddGadgetItem(#Combo_PortBaud,-1,"9600")
         AddGadgetItem(#Combo_PortBaud,-1,"14400")
         AddGadgetItem(#Combo_PortBaud,-1,"19200")
         AddGadgetItem(#Combo_PortBaud,-1,"38400")
         AddGadgetItem(#Combo_PortBaud,-1,"57600")
         AddGadgetItem(#Combo_PortBaud,-1,"115200")
         AddGadgetItem(#Combo_PortBaud,-1,"128000") 
        SetGadgetState(#Combo_PortBaud,11)
      TextGadget(#Text_PortState, 10, 45, 280, 15, "", #PB_Text_Center)
      TextGadget(#PB_Any, 10, 80, 75, 15, " ")
      StringGadget(#String_Byte_1, 95, 75, 40, 20, "")
      TextGadget(#PB_Any, 10, 105, 70, 15, " ")
      StringGadget(#String_Byte_2, 95, 100, 40, 20, "")
      
      HideWindow(#Window_0,0)
  EndIf
EndProcedure

Open_Window_0() ;   
NewCom(GetGadgetText(#Combo_PortName), Val(GetGadgetText(#Combo_PortBaud))) ;  
CreateThread(@InCOM_Thread(), 0) ;     

Repeat ;    Repeat - Until
  
  Event=WaitWindowEvent() ;    
  
  If Event=#PB_Event_Gadget ;   
    Gadget=EventGadget()     ;  ,    
    If Gadget=#Combo_PortName Or #Combo_PortBaud ;    
       If EventType()=1 ;   
        NewCom(GetGadgetText(#Combo_PortName), Val(GetGadgetText(#Combo_PortBaud)))  ;  
       EndIf
    EndIf
  EndIf
  
Until Event=#PB_Event_CloseWindow ;   

; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 115
; Folding = -
; EnableThread
; EnableXP
; UseIcon = .ico
; Executable = TepmoCOM.exe